#!/bin/sh

#
# ajoute-menu-dos-archive.sh - cree une archive de demarrage de Linux
#

RootDos=/dev/hda1

[ `id -u` != 0 ] && echo >&2 "Must be root - exit." && exit 1

cd `dirname $0`

if [ -f /boot/vmlinuz ]
then
    Kernel=/boot/vmlinuz
elif [ -f /vmlinuz ]
then
    Kernel=/vmlinuz
else
    echo >&2 "No kernel found - exit."
fi

#echo -n "Put a floppy in the A: drive and press Enter"
#read

#dd if=fd1440-dos-system.img of=/dev/fd0
#mcopy loadlin.exe a:
#mcopy $Kernel a:\vmlinuz
echo -e "loadlin c:\\\linux\\\root\\\vmlinuz root=$RootDos init=/linux/root/sbin/init ro\r" > linux.bat
#mcopy linux.bat a:autoexec.bat

echo -n "Creating linux/root"
[ -d linux ] && rm -rf linux && mkdir -p linux/root
echo "."

echo -n "Coping DOS files"
cp loadlin.exe linux.bat linux
echo "."

echo -n "Coping root filesystem"
(cd linux/root
tar xzf ../../creatux.tgz)
echo "."

echo -n "Coping kernel"
cp $Kernel linux/root/vmlinuz
echo "."

echo -n "Making archive"
tar czf linux.tgz linux
echo "."

