#!/bin/sh

#
# ajoute-menu-dos.sh - ajoute lors du boot de windows un menu permettant de
# lancer Linux
#

[ `id -u` != 0 ] && echo >&2 "Must be root - exit." && exit 1

cd `dirname $0`

PartitionDos=`fdisk -l | grep FAT | awk '{print $1}'`

[ -z "$PartitionDos" ] && echo >&2 "No FAT partition found." && exit 1

[ -d /tmp/Dos ] || mkdir /tmp/Dos
if cat /proc/mounts | grep "$PartitionDos" > /dev/null
then
    RepMontage=`cat /proc/mounts | grep "$PartitionDos" | awk '{print $2}'`
else
    mount $PartitionDos /tmp/Dos
    RepMontage=/tmp/Dos
fi

echo "Dos partition: $RepMontage"

if [ -f /boot/vmlinuz ]
then
    Kernel=/boot/vmlinuz
elif [ -f /vmlinuz ]
then
    Kernel=/vmlinuz
else
    echo >&2 "No kernel found - exit."
fi

echo "Kernel: $Kernel"
cp $Kernel $RepMontage

echo -n "Creating new $RepMontage/autoexec.bat file"
sed "/choice \/t:n,5 \"Load Linux \"/,/:End/d" < $RepMontage/autoexec.bat > $RepMontage/autoexec.bat.old

echo -e "choice /t:n,5 \"Load Linux \"\r
if errorlevel 2 goto End\r
c:linux\r
:End\r" > $RepMontage/autoexec.bat

cat $RepMontage/autoexec.bat.old >> $RepMontage/autoexec.bat
rm -f $RepMontage/autoexec.bat.old
echo " done"

echo -n "Creating new $RepMontage/windows/linux.bat file"
[ -f $RepMontage/windows/linux.bat ] && mv -f $RepMontage/windows/linux.bat $RepMontage/windows/linux.bat.old
echo -e "rem   linux.bat\r
smartdrv /C\r
loadlin c:\\\vmlinuz root=`rdev | awk '{print $1}'` ro\r" > $RepMontage/windows/linux.bat

echo " done"

echo -n "Updating $RepMontage/msdos.sys file"
sed "/Logo=/d" < $RepMontage/msdos.sys | (while read ligne
do
    echo "$ligne" | grep "\[Options\]" > /dev/null && echo -e "$ligne\nLogo=0\r" || echo -e "$ligne"
done) > $RepMontage/msdos.sys.old
mv -f $RepMontage/msdos.sys.old $RepMontage/msdos.sys
echo " done"

cp loadlin.exe $RepMontage/windows

[ "$RepMontage" = "/tmp/Dos" ] && umount /tmp/Dos
rmdir /tmp/Dos

exit 0
